package com.cyx.find;

import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Record;

import java.util.List;

/**
 * @Author Created by cyx.zhang Administrator on 2023/9/5 14:17 周二
 * @Description: TOTO
 */
public class EventFind {

  /**
   * 根据牛舍名称查询牛群类型
   * @param sourceCow
   * @param cowshedName
   * @return
   */
  public static Record getCowshedTypeByData(Long sourceCow,String cowshedName){
    String sql = "select cowshed_type as cowshedType from t_base_cowshed where source_cow='"+sourceCow+"' and cowshed_name='"+cowshedName+"'";
    return Db.findFirst(sql);
  }
  /**
   * 查询怀孕天数
   * @param sourceCow
   * @param cowNo
   * @param eventDate
   * @return
   */
  public static Record getDayByData(Long sourceCow,String cowNo,String eventDate){
    String sql = "select datediff(date_format('"+eventDate+"','%Y-%m-%d'),date_format(lately_breed_date,'%Y-%m-%d')) as day from t_breed_main where source_cow = '"+sourceCow+"' and cow_no = '"+cowNo+"' and date_format(lately_breed_date,'%Y-%m-%d') < date_format('"+eventDate+"','%Y-%m-%d') order by lately_breed_date desc limit 1";
    return Db.findFirst(sql);
  }
  /**
   * 查询牛只信息（犊牛[211]）
   * @param sourceCow
   * @param cowNo
   * @return
   */
  public static Record getCowByData(Long sourceCow,String cowNo){
    String sql = "select sex as calfSex,cow_type as calfType from t_base_cow where source_cow = '"+sourceCow+"' and cow_no = '"+cowNo+"' limit 1";
    return Db.findFirst(sql);
  }
  /**
   * 查询牛只信息(断奶/出岛[102])
   * @param sourceCow
   * @param cowNo
   * @return
   */
  public static Record getCowByData(Long sourceCow,String cowNo,String eventDate){
    String sql = "select date_format(birth_time,'%Y-%m-%d') as birthTime,birth_weight as birthWeight,datediff(date_format('"+eventDate+"','%Y-%m-%d'),date_format(birth_time,'%Y-%m-%d')) as dayAge from t_base_cow where source_cow = '"+sourceCow+"' and cow_no = '"+cowNo+"' limit 1";
    return Db.findFirst(sql);
  }
  /**
   * 查询牛只信息（死亡/淘汰）
   * @param sourceCow
   * @param cowNo
   * @param eventDate
   * @return
   */
  public static Record getCowInfoByData(Long sourceCow,String cowNo,String eventDate){
    String sql = "select sex as sex,date_format(birth_time,'%Y-%m-%d') as birthDate,datediff(date_format('"+eventDate+"','%Y-%m-%d'),date_format(birth_time,'%Y-%m-%d')) as dayAge from t_base_cow where source_cow = '"+sourceCow+"' and cow_no = '"+cowNo+"' limit 1";
    return Db.findFirst(sql);
  }
  /**
   * 查询繁育日期（死亡/淘汰）
   * @param sourceCow
   * @param cowNo
   * @return
   */
  public static Record getBreedDateByData(Long sourceCow,String cowNo){
    String sql = "select date_format(lately_breed_date,'%Y-%m-%d') as breedDate,date_format(lately_calving_date,'%Y-%m-%d') as calvingDate,date_format(lately_abortion_date,'%Y-%m-%d') as abortionDate from t_breed_main where source_cow = '"+sourceCow+"' and cow_no = '"+cowNo+"' limit 1";
    return Db.findFirst(sql);
  }
  /**
   * 计算产后天数
   * @param sourceCow
   * @param cowNo
   * @param eventDate
   * @return
   */
  public static Record getCalvingDayByData(Long sourceCow,String cowNo,String eventDate){
    String sql = "select datediff(date_format('"+eventDate+"','%Y-%m-%d'),date_format(lately_calving_date,'%Y-%m-%d')) as postDays from t_breed_main where source_cow = '"+sourceCow+"' and cow_no = '"+cowNo+"' limit 1";
    return Db.findFirst(sql);
  }
  /**
   * 计算流产天数
   * @param sourceCow
   * @param cowNo
   * @param eventDate
   * @return
   */
  public static Record getAbortionDayByData(Long sourceCow,String cowNo,String eventDate){
    String sql = "select datediff(date_format('"+eventDate+"','%Y-%m-%d'),date_format(lately_abortion_date,'%Y-%m-%d')) as abortionDays from t_breed_main where source_cow = '"+sourceCow+"' and cow_no = '"+cowNo+"' limit 1";
    return Db.findFirst(sql);
  }
  /**
   * 计算疾病治疗天数
   * @param sourceCow
   * @param cowNo
   * @param eventDate
   * @return
   */
  public static Record queryCowTreatmentDaysByData(Long sourceCow,String cowNo,String eventDate){
    String sql = "select datediff(date_format('"+eventDate+"','%Y-%m-%d'),date_format(discover_date,'%Y-%m-%d')) as treatmentDays,disease_name as diseaseName, describes as describes,id as diseaseRecordId from t_hm_disease_record where wether_cure = 0 and source_cow='"+sourceCow+"' and cow_no='"+cowNo+"' order by discover_date desc limit 1";
    return Db.findFirst(sql);
  }
  /**
   * @param sourceCow
   * @param cowNo
   * @param diseaseRecordId
   * @return
   */
  public static List<Record> queryTreatmentRecordIdByData(Long sourceCow, String cowNo, String diseaseRecordId){
    String sql = "select id as Id from t_hm_treatment_record where disease_record_id = '"+diseaseRecordId+"' and source_cow='"+sourceCow+"' and cow_no='"+cowNo+"'";
    List<Record> list = Db.find(sql);
    return list;
  }
  /**
   *
   * @param sourceCow
   * @param cowNo
   * @param treatmentRecordId
   * @return
   */
  public static List<Record> queryHmDrugRecordByData(Long sourceCow, String cowNo, String treatmentRecordId){
    String sql = "select drug_id as drugId,concat(dosage,unit) as dosage,date_format(create_time,'%Y-%m-%d %h:%i:%s') as createTime from t_hm_drug_record where treatment_record_id = '"+treatmentRecordId+"' and source_cow='"+sourceCow+"' and cow_no='"+cowNo+"'";
    List<Record> list = Db.find(sql);
    return list;
  }
  /**
   *
   * @param sourceCow
   * @param drugId
   * @return
   */
  public static List<Record> queryHmDrugByData(Long sourceCow, String drugId){
    String sql = " select drug_name as drugName from t_hm_drug where id = '"+drugId+"' and source_cow='"+sourceCow+"'";
    List<Record> list = Db.find(sql);
    return list;
  }

  /**
   * 根据牛场ID、牛号、事假日期查询转群转圈数据（获取事件牛舍、转入牛舍）
   * @param sourceCow
   * @param cowNo
   * @param eventDate
   * @return
   */
  public static Record getEventCowshedAndCowshedByData(Long sourceCow, String cowNo,String eventDate){
    String sql = "select curr_cowshed_name as cowshed,out_cows_type_name as cowType,cowshed_name as cowshedName,cows_type_name as cowshedType from t_event_turn_group where source_cow='"+sourceCow+"' and cow_no='"+cowNo+"' and event_date = date_format('"+eventDate+"','%Y-%m-%d') limit 1";
    return Db.findFirst(sql);
  }

  /**
   * 根据牛场ID、牛号、事假日期（区间）查询转群转圈数据（获取事件牛舍、转入牛舍）
   * @param sourceCow
   * @param cowNo
   * @param eventDate
   * @return
   */
  public static Record getCowshedByData(Long sourceCow, String cowNo,String eventDate){
    String sql = "select curr_cowshed_name as cowshed,out_cows_type_name as cowType,cowshed_name as cowshedName,cows_type_name as cowshedType from t_event_turn_group where source_cow='"+sourceCow+"' and cow_no='"+cowNo+"' and event_date between date_add(date_format('"+eventDate+"','%Y-%m-%d'),interval -1 day) and date_add(date_format('"+eventDate+"','%Y-%m-%d'),interval 2 day) order by event_date limit 1";
    return Db.findFirst(sql);
  }

  /**
   * 根据牛场ID、牛号查询转群转圈数据（转入牛舍）
   * @param sourceCow
   * @param cowNo
   * @return
   */
  public static Record getCowshedByData(Long sourceCow, String cowNo){
    String sql = "select curr_cowshed_name as cowshed,out_cows_type_name as cowType from t_event_turn_group where source_cow='"+sourceCow+"' and cow_no='"+cowNo+"' and out_cows_type_name ='哺乳犊牛' order by event_date limit 1";
    return Db.findFirst(sql);
  }
}
