package com.cyx.img;

import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.cyx.log.EventLog;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Record;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

/**
 * @Author Created by cyx.zhang Administrator on 2023/11/3 17:31 周五
 * @Description: TOTO
 */
public class Image {

  //存储图片地址
//  public static final String storage_address_folder = "D:/ruoyi/uploadPath/upload/";
  public static final String storage_address_folder = "/home/fileupload/ruoyi/uploadPath/upload/";
  //下载图片地址
  public static final String download_image_url = "https://cowimage.oss-cn-hangzhou.aliyuncs.com/big/";
  //上传图片存储地址
  public static final String upload_address_url = "/profile/upload/";

  public static final String upload_address_url_date = "/2023/12/19/";

  public static void syncBaseCowImage(JSONArray arrayList, Long sourceCow, String type){
    int count = 0;
    for(Object l : arrayList) {
      EventLog.info("...总量..." + arrayList.size()+"...条...剩余量..."+(arrayList.size()-count)+"...条...");
      JSONObject i = (JSONObject) l;
      String cowName = i.getString("cowName");
      String frontPhoto = i.getString("frontPhoto");
      String leftSidePhoto = i.getString("leftSidePhoto");
      String rightSidePhoto = i.getString("rightSidePhoto");
      if (frontPhoto != null && !"".equals(frontPhoto) && leftSidePhoto != null && !"".equals(leftSidePhoto) && rightSidePhoto != null && !"".equals(rightSidePhoto)) {
        EventLog.info("...cowName..." + cowName);
        EventLog.info("...frontPhoto..." + frontPhoto);
        EventLog.info("...leftSidePhoto..." + leftSidePhoto);
        EventLog.info("...rightSidePhoto..." + rightSidePhoto);
        // 指定文件夹路径
        Path folder = Paths.get(storage_address_folder+sourceCow+upload_address_url_date);
        EventLog.info("...存储地址..." + folder);
        // 检查文件夹是否存在
        if (!Files.exists(folder)) {
          try {
            // 如果文件夹不存在则创建
            Files.createDirectories(folder);
          } catch (IOException e) {
            // 创建文件夹时出现错误
            EventLog.info("...An error occurred while creating the folder...");
          }
        }

        try {
          String frontPhotoName = frontPhoto.substring(frontPhoto.lastIndexOf("/") + 1);
          String leftSidePhotoName = leftSidePhoto.substring(leftSidePhoto.lastIndexOf("/") + 1);
          String rightSidePhotoName = rightSidePhoto.substring(rightSidePhoto.lastIndexOf("/") + 1);

          //下载图片
          downloadImage(download_image_url + frontPhoto, folder.toString(), frontPhotoName);
          downloadImage(download_image_url + leftSidePhoto, folder.toString(), leftSidePhotoName);
          downloadImage(download_image_url + rightSidePhoto, folder.toString(), rightSidePhotoName);

          try {
            Thread.sleep(1000L);
          } catch (InterruptedException e) {
            e.printStackTrace();
          }
          //0-表示下载照片并入库
          if("0".equals(type)){
            /**
             * 更新牛只图片
             */
            String frontImage = upload_address_url + sourceCow + upload_address_url_date + frontPhotoName;
            String leftImage = upload_address_url + sourceCow + upload_address_url_date + leftSidePhotoName;
            String rightImage = upload_address_url + sourceCow + upload_address_url_date + rightSidePhotoName;
            //更新正面
            int aa = Db.update("update t_base_cow set front_image = '"+frontImage+"' where source_cow = '"+sourceCow+"' and cow_no = '"+cowName.trim().toUpperCase()+"'");
            EventLog.info("...cow...更新正面图片...["+aa+"]...");
            //更新左面
            int bb = Db.update("update t_base_cow set left_side_image = '"+leftImage+"'  where source_cow = '"+sourceCow+"' and cow_no = '"+cowName.trim().toUpperCase()+"'");
            EventLog.info("...cow...更新左面图片...["+bb+"]...");
            //更新右面
            int cc = Db.update("update t_base_cow set right_side_image = '"+rightImage+"'  where source_cow = '"+sourceCow+"' and cow_no = '"+cowName.trim().toUpperCase()+"'");
            EventLog.info("...cow...更新右面图片...["+cc+"]...");

            /**
             * 更新图片存储
             */
            String frontFileType = "image/jpeg";
            if(frontPhotoName.substring(frontPhotoName.lastIndexOf(".")).equals(".png")){
              frontFileType = "image/png";
            }
            String leftFileType = "image/jpeg";
            if(leftSidePhotoName.substring(leftSidePhotoName.lastIndexOf(".")).equals(".png")){
              leftFileType = "image/png";
            }
            String rightFileType = "image/jpeg";
            if(rightSidePhotoName.substring(rightSidePhotoName.lastIndexOf(".")).equals(".png")){
              rightFileType = "image/png";
            }
            //图片大小
            Path frontFilePath = Paths.get(folder.toString() + "/" + frontPhotoName);
            Long frontFileSize = Files.size(frontFilePath);
            Path leftFilePath = Paths.get(folder.toString() + "/" + leftSidePhotoName);
            Long leftFileSize = Files.size(leftFilePath);
            Path rightFilePath = Paths.get(folder.toString() + "/" + rightSidePhotoName);
            Long rightFileSize = Files.size(rightFilePath);


            Record record1 = Db.findFirst("select id as Id from t_base_files where source_cow = '"+sourceCow+"' and cow_no = '"+cowName.trim().toUpperCase()+"' and file_name = '"+frontPhotoName+"'");
            if(record1 == null){
              //新增正面
              int a = Db.update("insert into t_base_files (file_name,path,file_type,file_size,source_cow,cow_no,create_by,remark) values ('"+frontPhotoName+"','"+frontImage+"','"+frontFileType+"','"+frontFileSize+"','"+sourceCow+"','"+cowName.trim().toUpperCase()+"','张渊麒','正面')");
              EventLog.info("...files...新增正面图片...["+a+"]...");
            }else {
              //更新正面
              int a = Db.update("update t_base_files set file_name = '"+frontPhotoName+"',path = '"+frontImage+"',file_type = '"+frontFileType+"',file_size = '"+frontFileSize+"',source_cow = '"+sourceCow+"',cow_no = '"+cowName.trim().toUpperCase()+"',update_by='张渊麒',remark='正面' where id = '"+record1.getStr("Id")+"'");
              EventLog.info("...files...更新正面图片...["+a+"]...");
            }

            Record record2 = Db.findFirst("select id as Id from t_base_files where source_cow = '"+sourceCow+"' and cow_no = '"+cowName.trim().toUpperCase()+"' and file_name = '"+leftSidePhotoName+"'");
            if(record2 == null){
              //新增左面
              int b = Db.update("insert into t_base_files (file_name,path,file_type,file_size,source_cow,cow_no,create_by,remark) values ('"+leftSidePhotoName+"','"+leftImage+"','"+leftFileType+"','"+leftFileSize+"','"+sourceCow+"','"+cowName.trim().toUpperCase()+"','张渊麒','左面')");
              EventLog.info("...files...新增左面图片...["+b+"]...");
            }else {
              //更新左面
              int b = Db.update("update t_base_files set file_name = '" + leftSidePhotoName + "',path = '" + leftImage + "',file_type = '" + leftFileType + "',file_size = '" + leftFileSize + "',source_cow = '" + sourceCow + "',cow_no = '" + cowName.trim().toUpperCase() + "',update_by='张渊麒',remark='左面' where id = '" + record2.getStr("Id") + "'");
              EventLog.info("...files...更新左面图片...[" + b + "]...");
            }
            Record record3 = Db.findFirst("select id as Id from t_base_files where source_cow = '"+sourceCow+"' and cow_no = '"+cowName.trim().toUpperCase()+"' and file_name = '"+rightSidePhotoName+"'");
            if(record3 == null){
              //新增右面
              int c = Db.update("insert into t_base_files (file_name,path,file_type,file_size,source_cow,cow_no,create_by,remark) values ('"+rightSidePhotoName+"','"+rightImage+"','"+rightFileType+"','"+rightFileSize+"','"+sourceCow+"','"+cowName.trim().toUpperCase()+"','张渊麒','右面')");
              EventLog.info("...files...新增右面图片...["+c+"]...");
            }else {
              //更新右面
              int c = Db.update("update t_base_files set file_name = '" + rightSidePhotoName + "',path = '" + rightImage + "',file_type = '" + rightFileType + "',file_size = '" + rightFileSize + "',source_cow = '" + sourceCow + "',cow_no = '" + cowName.trim().toUpperCase() + "',update_by='张渊麒',remark='右面' where id = '" + record3.getStr("Id") + "'");
              EventLog.info("...files...更新右面图片...[" + c + "]...");
            }
          }
        } catch (Exception e) {
          EventLog.info("...An error occurred while downloading and upload the image...");
        }
      }else{
        EventLog.info("...["+cowName+"]..."+"...未查到照片...");
      }
      count++;
    }
  }

  /**
   * 图片下载
   * @param imageUrl
   * @param targetDirectory
   * @param fileName
   */
  public static void downloadImage(String imageUrl, String targetDirectory, String fileName){
    try {
      String targetFile = targetDirectory +"/"+ fileName;
      URL url = new URL(imageUrl);
      HttpURLConnection conn = (HttpURLConnection) url.openConnection();
      conn.setRequestMethod("GET");
      conn.connect();

      InputStream in = conn.getInputStream();
      OutputStream out = new FileOutputStream(targetFile);

      byte[] buffer = new byte[1024];
      int len;
      while ((len = in.read(buffer)) != -1) {
        out.write(buffer, 0, len);
      }
      out.close();
      in.close();
    } catch (IOException e) {
      e.printStackTrace();
    }
  }

}
